﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;
using System.Reflection;
using System.IO;

namespace Sample1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Save("Series Number: example\n Prefix: example \n Temparature: 25,8");
        }

        private void Save(string text=null)
        {
            TextBlock textBlock = null;

            if (text != null)
            {
                textBlock = new TextBlock()
                {
                    Text = text,
                    FontFamily = new FontFamily("Arial"),
                    FontSize = 17,
                    Margin = new Thickness(90, 30, 0, 0)
                };
                grid.Children.Add(textBlock);
            }


            sfChart.GetType().GetMethod("RenderSeries", BindingFlags.NonPublic |
                BindingFlags.Instance).Invoke(sfChart, null);
            sfChart.UpdateLayout();
            grid.UpdateLayout();

            RenderTargetBitmap bmpSource = new RenderTargetBitmap((int)grid.ActualWidth, (int)grid.ActualHeight, 96, 96, PixelFormats.Pbgra32);
            bmpSource.Render(grid);
            BitmapEncoder imgEncoder = new PngBitmapEncoder();
            imgEncoder.Frames.Add(BitmapFrame.Create(bmpSource));
            using (Stream stream = File.Create(@"D:\chart.png"))
            {
                imgEncoder.Save(stream);
            }

            if (textBlock !=null)
                grid.Children.Remove(textBlock);
        }
    }

    public class Model
    {
        public double XValue { get; set; }
        public double YValue { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            GenerateData();           
        }

        public void GenerateData()
        {
            Data = new ObservableCollection<Model>();
            Random rd = new Random();
            for (int i = 0; i < 6; i++)
            {
                Data.Add(new Model()
                {
                    XValue = i,
                    YValue = rd.Next(0, 50)
                });
            }
        }

        private ObservableCollection<Model> data;

        public ObservableCollection<Model> Data
        {
            get { return data; }
            set { data = value;  }
        }

        
       
    }
    
}
